#property copyright "modified by MobiDik"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Green
#property indicator_color6 Red
//#property indicator_color7 clrNONE//Magenta
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

extern int Processed        = 2000;
extern int Control_Period   = 14;
extern int shift            = 2;

double val[],val_1[],values1[],values2[];
double val_up[],val_up1[];
double val_dn[],val_dn1[];

int init() {
  SetIndexStyle(5, DRAW_LINE);      SetIndexBuffer(5, val_up);  SetIndexLabel(5,"val_up");
  SetIndexStyle(1, DRAW_LINE);      SetIndexBuffer(1, val);     SetIndexLabel(1,"val");
  SetIndexStyle(2, DRAW_LINE);      SetIndexBuffer(2, val_dn);  SetIndexLabel(2,"val_dn");
  SetIndexStyle(3, DRAW_HISTOGRAM); SetIndexBuffer(3, val_up1); SetIndexLabel(3,"val_up1"); 
  SetIndexStyle(4, DRAW_HISTOGRAM); SetIndexBuffer(4, val_dn1); SetIndexLabel(4,"val_dn1");
  SetIndexStyle(0, DRAW_HISTOGRAM); SetIndexBuffer(0, val_1);   SetIndexLabel(0,"val_1"); 
//  SetIndexStyle(6, DRAW_LINE);      SetIndexBuffer(6, values2); SetIndexLabel(6,"values2"); 
  return (0);
}

int deinit() {
  return (0);
}

int start() {
  datetime bar_time;
  int i, counter, offset, bar_shft, bar_cont;
  double price_high, price_close, price_low, trigger_high, trigger_low;
  double sum_up, sum_dn, complex_up, complex_dn;

  int counted = IndicatorCounted();
  if (counted < 0) return (-1);
  if (counted > 0) counted--;
  int limit = Bars - counted;
  if (limit > Processed) limit = Processed;

  for (i = limit; i >= 0; i--) {
    counter = 0;
    complex_up = 0; complex_dn = 0;
    trigger_high = -999999; trigger_low  = 999999;

    while (counter < Control_Period) {
      sum_up = 0; sum_dn = 0;
         
      offset = i + counter;
      bar_time = iTime(Symbol(), 0, offset);
      bar_shft = iBarShift(Symbol(), 0, bar_time, FALSE);
      bar_cont = bar_shft - Period(); if (bar_cont < 0) bar_cont = 0;
         
      for (int jdx = bar_shft; jdx >= bar_cont; jdx--) {   
        price_high  = iHigh(Symbol(), 0, jdx); 
        price_close = iClose(Symbol(), 0, jdx); 
        price_low   = iLow(Symbol(), 0, jdx);
        if (price_high > trigger_high) {trigger_high = price_high; sum_up += price_close;}
        if (price_low  < trigger_low ) {trigger_low  = price_low;  sum_dn += price_close;}
      }
     
      counter++;
      complex_up += sum_up; complex_dn += sum_dn;        
    }
    if (complex_dn != 0.0 && complex_up != 0.0)
    { 
     int ddd = 1;
     double values_up = (complex_dn / complex_up - complex_up / complex_dn)+ddd;
     double values_dn = (complex_dn / complex_up - complex_up / complex_dn)-ddd;

     if(values_up>0){ 
      val[i] = values_up;
      val_1[i] = values_up;
      val_up[i-3] = values_up;
      val_up1[i-3] = values_up; 
      }else{ 
      val_up[i-3]=0;
      val_up[i-3]=0;
      }
      
     if(values_dn<0){ 
      val[i] = values_dn; 
      val_1[i] = values_dn;
      val_dn[i-3] = values_dn;
      val_dn1[i-3] = values_dn; 
      }else{ 
      val_dn[i-3]=0;
      val_dn1[i-3]=0;
      }
    } 
  }
/*
  for (i = limit; i >= 0; i--)
  {    
    if(values[i]>0)
    {
      val_up[i]  = values[i+shift];
      val_up1[i] = 0;//values[i+shift];
      } else {
      val_up[i]  = 0;//EMPTY_VALUE;
      val_up1[i] = 0;//EMPTY_VALUE;
      }
      
    if(values2[i]<0){
      val_dn[i]  = values2[i+shift];
      val_dn1[i] = 0;//values2[i+shift];
      } else {
      val_dn[i]  = 0;//EMPTY_VALUE;
      val_dn1[i] = 0;//EMPTY_VALUE;
      }      
  } */
  return (0);
}